
       IDENTIFICATION DIVISION.
       PROGRAM-ID. fbenchm.
       AUTHOR.     DAV.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  KEY-COMPARE.
           03  KEY0                  PIC X(9)  value  low-values.
           03  KEY1                  PIC X(20)  value  low-values.
           03  KEY2                  PIC X(20)  value  low-values.
       01  KEY-SAVED.
           03  PK-SAVED              PIC X(9)  value  low-values.
           03  AK1-SAVED             PIC X(20)  value  low-values.
           03  AK2-SAVED             PIC X(20)  value  low-values.
       01  f-size-saved.
           03  f-size-pk             pic 9(2)  value zeros.
           03  f-size-ak1            pic 9(2)  value zeros.
           03  f-size-ak2            pic 9(2)  value zeros.

       01  W-ABRE                    PIC X value "N".
       01  LNGTH-PK                  PIC S9(4) BINARY VALUE 9.
       01  LNGTH-AK1                 PIC S9(4) BINARY VALUE 20.
       01  LNGTH-AK2                 PIC S9(4) BINARY VALUE 20.
       01  DESDE                     pic s9(4) binary value zeros.
       01  HASTA                     pic s9(4) binary value zeros.
       01  status-verifica           pic 9 value zeros.
       01  INDICADORES.
           03  LASTOPERA             PIC S9(4) BINARY VALUE ZEROS.
           03  LASTCURSOR            PIC X(6)  VALUE SPACES.
           03  INDICADORES-START.
               05  START-PK          PIC 9      VALUE ZEROS.
               05  OPEN-PK           PIC 9      VALUE ZEROS.
               05  ROWID-START-PK    PIC X(18)  VALUE LOW-VALUE.
               05  START-AK1         PIC 9      VALUE ZEROS.
               05  OPEN-AK1          PIC 9      VALUE ZEROS.
               05  ROWID-START-AK1   PIC X(18)  VALUE LOW-VALUE.
               05  START-AK2         PIC 9      VALUE ZEROS.
               05  OPEN-AK2          PIC 9      VALUE ZEROS.
               05  ROWID-START-AK2   PIC X(18)  VALUE LOW-VALUE.

       01  kk                   pic x  value spaces.
       01  TIEMPOS-WS.
           03  TGLOBALCOM                    PIC 9(8).
           03  TGLOBALFIN                    PIC 9(8).
           03  TGLOBALDIF                    PIC 9(8).
       01  TT.
           03  HH        PIC 99.
           03  MM        PIC 99.
           03  SS        PIC 99.
           03  CC        PIC 99.
       01  TTW           PIC 9(8).

       01  BENCHM-RECORD-SAVED pic x(129).

       exec sql include SQLCA    end-exec.

       exec sql begin declare section  end-exec.

       01  userid      pic x(10)  value "david".
       01  passwd      pic x(10)  value "alcodag1".
       01  rowid       pic x(18).
       01  benchm-key1-start          pic x(3).
       01  BENCHM-KEY2-start          pic x(6).
       01  BENCHM-ALTKY11-start       pic x(6).
       01  BENCHM-ALTKY12-start       pic x(8).
       01  BENCHM-ALTKY13-start       pic x(6).
       01  BENCHM-ALTKY21-start       pic x(6).
       01  BENCHM-ALTKY22-start       pic x(8).
       01  BENCHM-ALTKY23-start       pic x(6).

      ****** lrecl.129  lpk.9  lak1.20  lak2.20  ***********
       01  BENCHM-RECORD.
           03  BENCHM-KEY.
               05  BENCHM-KEY1             PIC X(3).
               05  BENCHM-KEY2             PIC X(6).
           03  BENCHM-DATOS1                   PIC X(20).
           03  BENCHM-ALTKY1.
               05  BENCHM-ALTKY11          PIC X(6).
               05  BENCHM-ALTKY12          PIC X(8).
               05  BENCHM-ALTKY13          PIC X(6).
           03  BENCHM-DATOS2                   PIC X(20).
           03  BENCHM-DATOS3                   PIC X(20).
           03  BENCHM-ALTKY2.
               05  BENCHM-ALTKY21          PIC X(6).
               05  BENCHM-ALTKY22          PIC X(8).
               05  BENCHM-ALTKY23          PIC X(6).
           03  BENCHM-DATOS4                   PIC X(20).

       exec sql end declare section  end-exec.


       LINKAGE SECTION.
       01  F-PARAMETROS.
           03  F-OPEN               PIC XX.
           03  F-FUN                PIC S9(4) BINARY.
           03  F-NCLAVE             PIC 9(1).
           03  F-SIZE               PIC 9(2).
           03  F-FLAG               PIC X(1).
           03  F-PROGID             PIC X(10).
       01  F-RECORD   PIC X(129).

       PROCEDURE DIVISION  USING    F-PARAMETROS
                                    F-RECORD.
       COMIENZO.
           move   "0"        to f-flag.
           PERFORM TIEMPOS   MOVE TTW TO TGLOBALCOM.
           if  w-abre = "S"
               go to   verifica-funcion.

       INICIALIZA.
           move  "S"  to  w-abre.

       CONNECCION-BASE.
***********display "fbenchm- connecion base ".
           exec sql database veraz end-exec.
           exec sql set isolation to repeatable read end-exec.
           exec sql set lock mode to wait end-exec.
           exec sql whenever error continue end-exec.


       DECLARE-CURSORES-PK.

***********display "fbenchm- declare cursor pk ".
           exec sql declare cur_smi_pk cursor with hold for
                        select bkey1, bkey2, bdatos1, baltky11,
                               baltky12, baltky13,
                               bdatos2, bdatos3,
                               baltky21, baltky22, baltky23,
                               bdatos4, rowid
                        into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
             from     benchm
             where
                    (bkey1 = :BENCHM-KEY1 and bkey2 >= :BENCHM-KEY2)
                 or
                    (bkey1 > :BENCHM-KEY1)
             for update
           end-exec.

           exec sql declare cur_sma_pk cursor with hold for
                        select bkey1, bkey2, bdatos1, baltky11,
                               baltky12, baltky13,
                               bdatos2, bdatos3,
                               baltky21, baltky22, baltky23,
                               bdatos4, rowid
                        into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
             from     benchm
             where
                    (bkey1 = :BENCHM-KEY1 and bkey2 > :BENCHM-KEY2)
                 or
                    (bkey1 > :BENCHM-KEY1)
             for  update
           end-exec.

           exec sql declare cur_sig_pk cursor with hold for
                        select bkey1, bkey2, bdatos1, baltky11,
                               baltky12, baltky13,
                               bdatos2, bdatos3,
                               baltky21, baltky22, baltky23,
                               bdatos4, rowid
                        into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
             from     benchm
             where
                    (bkey1 = :BENCHM-KEY1 and bkey2 = :BENCHM-KEY2)
           end-exec.

           exec sql declare cur_sig_pkh cursor with hold for
                        select bkey1, bkey2, bdatos1, baltky11,
                               baltky12, baltky13,
                               bdatos2, bdatos3,
                               baltky21, baltky22, baltky23,
                               bdatos4, rowid
                        into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
             from     benchm
             where
                    (bkey1 = :BENCHM-KEY1 and bkey2 = :BENCHM-KEY2)
                    for  update
           end-exec.


***********display "fbenchm- declare cursor ak1".
           exec sql declare cur_smi_ak1 cursor with hold for
                        select bkey1, bkey2, bdatos1, baltky11,
                               baltky12, baltky13,
                               bdatos2, bdatos3,
                               baltky21, baltky22, baltky23,
                               bdatos4, rowid
                        into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
             from     benchm
             where
                    ( baltky11  =   :BENCHM-ALTKY11 and
                      baltky12  =   :BENCHM-ALTKY12 and
                      baltky13  >=  :BENCHM-ALTKY13 )
                 or
                    ( baltky11  =   :BENCHM-ALTKY11 and
                      baltky12  >   :BENCHM-ALTKY12 )
                 or
                    ( baltky11  >   :BENCHM-ALTKY11 )
             for update
           end-exec.

           exec sql declare cur_sma_ak1 cursor with hold for
                        select bkey1, bkey2, bdatos1, baltky11,
                               baltky12, baltky13,
                               bdatos2, bdatos3,
                               baltky21, baltky22, baltky23,
                               bdatos4, rowid
                        into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
             from     benchm
             where
                    ( baltky11  =   :BENCHM-ALTKY11 and
                      baltky12  =   :BENCHM-ALTKY12 and
                      baltky13  >   :BENCHM-ALTKY13 )
                 or
                    ( baltky11  =   :BENCHM-ALTKY11 and
                      baltky12  >   :BENCHM-ALTKY12 )
                 or
                    ( baltky11  >   :BENCHM-ALTKY11 )
             for update
           end-exec.



       VERIFICA-FUNCION.
           GO TO    R-READ-NEXT
                    R-READ-NEXT-HOLD
                    R-START-POR-MAYOR
                    R-START-POR-MAYOR-IGUAL

                    R-READ-PREVIO
                    R-READ-PREVIO-HOLD
                    R-START-POR-MENOR
                    R-START-POR-MENOR-IGUAL

                    R-READ-KEY
                    R-READ-KEY-HOLD
                    R-START-POR-IGUAL

                    R-WRITE
                    R-REWRITE
                    R-DELETE

                    R-SCRATCH
                    R-CLOSE
                    R-CREATE
                                            DEPENDING ON F-FUN.


       VERIFICA-CLAVES.
             move  zeros  to  status-verifica.


       SALIDA-NORMAL.
           PERFORM TIEMPOS      MOVE TTW TO TGLOBALFIN.
           COMPUTE TGLOBALDIF = TGLOBALFIN - TGLOBALCOM.
                EXIT PROGRAM.


      **************************************************************
      ***********************  RIN  /  RIH  ************************
       R-READ-KEY.
       R-READ-KEY-HOLD.
***********display "fbenchm- rin/rih ".
           move  spaces  to  key-saved.
           move  f-record(1:9)  to  BENCHM-key.
      *------------- f-fun=9   RIN
           if  f-fun  not =  9
               go to  rih.

       RIN.
       exec sql  begin work end-exec.
      ****    exec sql  close  cur_sig_pk   end-exec.
               exec sql  open cur_sig_pk end-exec
               exec sql  fetch cur_sig_pk
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec.

        RIH.  
        exec sql  begin work end-exec.
               exec sql  close  cur_sig_pkh   end-exec.
               exec sql  open cur_sig_pkh end-exec
               exec sql  fetch cur_sig_pkh
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec.


           if  sqlcode not = zeros
                     if  sqlcode  =  100
                         MOVE 2          TO F-FLAG
                         move  f-fun       to  lastopera
                         move  spaces      to  lastcursor
                         go to  salida-normal
                     else
                         go to  muestro-error.

           if  BENCHM-key  not =  f-record(1:9)
                       MOVE 2          TO F-FLAG
                       move  f-fun       to  lastopera
                       move  spaces      to  lastcursor
                       go to  salida-normal.

      *-------- inicializa cursor por posible rne/rnh sobre pk.
           move  zeros  to  f-size.
           exec sql  close  cur_sma_pk   end-exec.
           exec sql  open  cur_sma_pk  end-exec.
           move  "smapk "  to  lastcursor.
           move  1         to  open-pk.

           MOVE  BENCHM-record  TO   F-RECORD.
           move  benchm-key      to   pk-saved.
           move  benchm-altky1   to   ak1-saved.
           move  f-fun       to  lastopera.
           go to  salida-normal.


      **************************************************************
      ************************  RNE / RNH   ************************
       R-READ-NEXT.
       R-READ-NEXT-HOLD.
***********display "fbenchm- rne "  lastcursor.
           move  spaces  to  key-saved.
           if  lastcursor = "sigpk "    go to  rne-pk.
           if  lastcursor = "smipk "    go to  rne-pk.
           if  lastcursor = "smapk "    go to  rne-pk.
           if  lastcursor = "sigak1"    go to  rne-ak1.
           if  lastcursor = "smiak1"    go to  rne-ak1.
           if  lastcursor = "smaak1"    go to  rne-ak1.

           move  zeros  to  f-size.
           move  "smipk "    to  lastcursor.
           move  low-values  to  BENCHM-key.

      *---------------------------------------------
      *------ RNE / RNH    Por clave primaria
       rne-pk.
           if  start-pk  =  1
***********display "fbenchm- hubo start pk rne"
               move  rowid-start-pk   to   rowid
               MOVE  BENCHM-record-saved to  F-RECORD
               move  benchm-key      to   pk-saved
               move  benchm-altky1   to   ak1-saved
               move  f-fun         to  lastopera
               move  zeros         to  start-pk
               move  low-values  to  rowid-start-pk
               go to  salida-normal.

           if  open-pk  =  zeros
***********display "fbenchm- rne open cursor"
               if  f-size not = zeros
                   compute desde = f-size + 1
                   compute hasta = lngth-pk  -  f-size
                   move  low-values  to  benchm-key(desde:hasta)
               end-if
               if  lastcursor = "smipk " or lastcursor = "sigpk "
                   exec sql close cur_smi_pk  end-exec
                   exec sql  open cur_smi_pk end-exec
               else
                   exec sql close cur_sma_pk  end-exec
                   exec sql  open cur_sma_pk end-exec
               end-if
               move  1  to  open-pk.

       rne-pk-fetch.
***********display "fbenchm- rne pk fetch"  lastcursor.
           if  lastcursor = "smipk "  or  lastcursor = "sigpk "
          exec sql  begin work end-exec
               exec sql  fetch cur_smi_pk
                   into
                                :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec
***********display sqlcode  
                
           else
            exec sql  begin work end-exec
               exec sql  fetch cur_sma_pk
                   into
                                :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec.

           if  sqlcode not = zeros
               if  sqlcode  =  100
                   MOVE 2          TO F-FLAG
                   move  f-fun       to  lastopera
                   move  low-values  to  rowid-start-pk
                   move  zeros       to  start-pk
                   go to  salida-normal
               else
                   go to  muestro-error.

           MOVE  BENCHM-record to  F-RECORD.
           move  benchm-key      to   pk-saved.
           move  benchm-altky1   to   ak1-saved.
           move  f-fun         to  lastopera.
           move  zeros         to  start-pk.
           move  low-values  to  rowid-start-pk
           go to  salida-normal.



      *-------------------------------------------------
      *------ RNE / RNH    Por clave alternativa 1
       rne-ak1.
           if  start-ak1  =  1
***********display "fbenchm- hubo start ak1 rne"
               move  rowid-start-ak1   to   rowid
               MOVE  BENCHM-record-saved to  F-RECORD
               move  benchm-key      to   pk-saved
               move  benchm-altky1   to   ak1-saved
               move  f-fun         to  lastopera
               move  zeros         to  start-ak1
               move  low-values  to  rowid-start-ak1
               go to  salida-normal.

           if  open-ak1  =  zeros
***********display "fbenchm- rne open cursor"
               if  f-size not = zeros
                   compute desde = f-size + 1
                   compute hasta = lngth-ak1  -  f-size
                   move  low-values  to  benchm-altky1(desde:hasta)
               end-if
               if  lastcursor = "smiak1" or lastcursor = "sigak1"
                   exec sql  close  cur_smi_ak1   end-exec
                   exec sql  open cur_smi_ak1 end-exec
               else
                   exec sql  close  cur_sma_ak1   end-exec
                   exec sql  open cur_sma_ak1 end-exec
               end-if
               move  1  to  open-ak1.

       rne-ak1-fetch.
***********display "fbenchm- rne ak1 fetch"  lastcursor.
           if  lastcursor = "smiak1" or lastcursor = "sigak1"
              exec sql  begin work end-exec
               exec sql  fetch cur_smi_ak1
                   into
                                :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec
***********display sqlcode
           else
             exec sql  begin work end-exec
               exec sql  fetch cur_sma_ak1
                   into
                                :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec.

           if  sqlcode not = zeros
***********display sqlcode
               if  sqlcode  =  100
                   MOVE 2          TO F-FLAG
                   move  f-fun       to  lastopera
                   move  low-values  to  rowid-start-ak1
                   move  zeros       to  start-ak1
                   go to  salida-normal
               else
                   go to  muestro-error.

           MOVE  BENCHM-record to  F-RECORD.
           move  benchm-key      to   pk-saved.
           move  benchm-altky1   to   ak1-saved.
           move  f-fun         to  lastopera.
           move  zeros         to  start-ak1.
           move  low-values  to  rowid-start-ak1
           go to  salida-normal.



      **************************************************************
      ************************   SMI   *****************************
       R-START-POR-MAYOR-IGUAL.
***********display "fbenchm- smi ".
           MOVE F-RECORD TO benchm-record.
           GO TO     R-START-POR-MAYOR-IGUAL-AK1
                        depending on  f-nclave.

      *------------------------------------- SMI PK
       R-START-POR-MAYOR-IGUAL-PK.
***********display "fbenchm- smi pk".
           if  f-size not = zeros
               compute desde = f-size + 1
               compute hasta = lngth-pk  -  f-size
               move  low-values  to  benchm-key(desde:hasta).

           if  benchm-key  =  spaces
               move  low-values  to  benchm-key.

***********display "fbenchm- start open/fetch pk".
            exec sql  begin work end-exec.
           exec sql  close cur_smi_pk end-exec.
           exec sql  open cur_smi_pk end-exec.
               exec sql  fetch cur_smi_pk
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
               end-exec.

           if  sqlcode not = zeros
               if  sqlcode  =  100
                   MOVE 2          TO F-FLAG
                   move  f-fun       to  lastopera
                   move  "smipk "    to  lastcursor
                   move  low-values  to  rowid-start-pk
                   move  zeros       to  start-pk
                   move  zeros       to  open-pk
                   go to  salida-normal
               else
                   go to  muestro-error.

           move BENCHM-RECORD to BENCHM-RECORD-SAVED.
           move  1       to    start-pk.
           move  1       to    open-pk.
           move  rowid   to    rowid-start-pk.
           move  f-fun       to  lastopera.
           move  "smipk "    to  lastcursor.
           go to  salida-normal.

      *------------------------------------- SMI AK1
       R-START-POR-MAYOR-IGUAL-AK1.
***********display "fbenchm- smi ak1".
           if  f-size not = zeros
               compute desde = f-size + 1
               compute hasta = lngth-ak1  -  f-size
               move  low-values  to  benchm-altky1(desde:hasta).

           if  benchm-altky1  =  spaces
               move  low-values  to  benchm-altky1.
***********display benchm-altky1.

***********display "fbenchm- start open/fetch ak1 ".
           exec sql  begin work end-exec.
           exec sql  close cur_smi_ak1 end-exec.
           exec sql  open cur_smi_ak1 end-exec.
           exec sql  fetch cur_smi_ak1
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
           end-exec.
*      display BENCHM-KEY1.
*           display BENCHM-KEY2.
*           display sqlcode.
           if  sqlcode not = zeros
               if  sqlcode  =  100
                   MOVE 2          TO F-FLAG
                   move  f-fun       to  lastopera
                   move  "smiak1"    to  lastcursor
                   move  low-values  to  rowid-start-ak1
                   move  zeros       to  start-ak1
                   move  zeros       to  open-ak1
                   go to  salida-normal
               else
                   go to  muestro-error.

           move BENCHM-RECORD to BENCHM-RECORD-SAVED.
           move  1       to    start-ak1.
           move  1       to    open-ak1.
           move  rowid   to    rowid-start-ak1.
           move  f-fun       to  lastopera.
           move  "smiak1"    to  lastcursor.
           go to  salida-normal.



      **************************************************************
      ************************   SMA   *****************************
       R-START-POR-MAYOR.
***********display "fbenchm- sma ".
           MOVE F-RECORD TO benchm-record.
           GO TO     R-START-POR-MAYOR-AK1
                        depending on  f-nclave.

      *------------------------------------- SMA PK
       R-START-POR-MAYOR-PK.
***********display "fbenchm- sma pk".
           if  f-size not = zeros
               compute desde = f-size + 1
               compute hasta = lngth-pk  -  f-size
               move  high-values  to  benchm-key(desde:hasta)
               move  f-size      to  f-size-pk.

           if  benchm-key  =  spaces
               move  low-values  to  benchm-key.

***********display "fbenchm- sma open/fetch pk".
               exec sql  begin work end-exec.
           exec sql  close cur_sma_pk end-exec.
           exec sql  open cur_sma_pk end-exec.
           exec sql  fetch cur_sma_pk
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
           end-exec.
           if  sqlcode not = zeros
               if  sqlcode  =  100
                   MOVE 2          TO F-FLAG
                   move  f-fun       to  lastopera
                   move  "smapk "    to  lastcursor
                   move  low-values  to  rowid-start-pk
                   move  zeros       to  start-pk
                   move  zeros       to  open-pk
                   go to  salida-normal
               else
                   go to  muestro-error.

           move BENCHM-RECORD to BENCHM-RECORD-SAVED.
           move  1       to    start-pk.
           move  1       to    open-pk.
           move  rowid   to    rowid-start-pk.
           move  f-fun       to  lastopera.
           move  "smapk "    to  lastcursor.
           go to  salida-normal.

      *------------------------------------- SMA AK1
       R-START-POR-MAYOR-AK1.
***********display "fbenchm- sma ak1".
           if  f-size not = zeros
               compute desde = f-size + 1
               compute hasta = lngth-ak1  -  f-size
               move  high-values  to  benchm-altky1(desde:hasta).

           if  benchm-altky1  =  spaces
               move  low-values  to  benchm-altky1.

***********display "fbenchm- sma open/fetch ak1 ".
        exec sql  begin work end-exec.
           exec sql  close cur_sma_ak1 end-exec.
           exec sql  open cur_sma_ak1 end-exec.
           exec sql  fetch cur_sma_ak1
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
           end-exec.

           if  sqlcode not = zeros
               if  sqlcode  =  100
                   MOVE 2          TO F-FLAG
                   move  f-fun       to  lastopera
                   move  "smaak1"    to  lastcursor
                   move  low-values  to  rowid-start-ak1
                   move  zeros       to  start-ak1
                   move  zeros       to  open-ak1
                   go to  salida-normal
               else
                   go to  muestro-error.

           move BENCHM-RECORD to BENCHM-RECORD-SAVED.
           move  1       to    start-ak1.
           move  1       to    open-ak1.
           move  rowid   to    rowid-start-ak1.
           move  f-fun       to  lastopera.
           move  "smaak1"    to  lastcursor.
           go to  salida-normal.




      **************************************************************
      ************************   SIG   *****************************
       R-START-POR-IGUAL.
***********display "fbenchm- sig ".
           MOVE F-RECORD TO BENCHM-record.
           go to  r-start-por-igual-ak1
                  depending on   f-nclave.

      *------------------------------------- SIG PK
       R-START-POR-IGUAL-PK.
***********display "fbenchm- sig pk".
           move  benchm-key  to  key0.
           if  f-size not = zeros
               compute desde = f-size + 1
               compute hasta = lngth-pk  -  f-size
               move  low-values  to  BENCHM-key(desde:hasta)
               move  f-size      to  f-size-pk.

           if  BENCHM-key = spaces  or  benchm-key = low-values
               move  2   to   f-flag
               move  f-fun       to  lastopera
               move  "sigpk "    to  lastcursor
               move  low-values  to  rowid-start-pk
               move  zeros       to  start-pk
               move  zeros       to  open-pk
               go to  salida-normal.

***********display "fbenchm- sig open/fetch pk".
        exec sql  begin work end-exec.
           exec sql  close cur_smi_pk end-exec.
           exec sql  open cur_smi_pk end-exec.
           exec sql  fetch cur_smi_pk
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
           end-exec.

           if  sqlcode not = zeros
               if  sqlcode  =  100
                   move  2   to   f-flag
                   move  f-fun       to  lastopera
                   move  "sigpk "    to  lastcursor
                   move  low-values  to  rowid-start-pk
                   move  zeros       to  start-pk
                   move  zeros       to  open-pk
                   go to  salida-normal
               else
                   go to  muestro-error.

           if  f-size  =  zeros
               if  benchm-key  not =    key0
                   move  2   to   f-flag
                   move  f-fun       to  lastopera
                   move  "sigpk "    to  lastcursor
                   move  low-values  to  rowid-start-pk
                   move  zeros       to  start-pk
                   move  zeros       to  open-pk
                   go to  salida-normal
               else
                   next sentence
               end-if
           else
               if  benchm-key(1:f-size)  not =  key0(1:f-size)
                   move  2   to   f-flag
                   move  f-fun       to  lastopera
                   move  "sigpk "    to  lastcursor
                   move  low-values  to  rowid-start-pk
                   move  zeros       to  start-pk
                   move  zeros       to  open-pk
                   go to  salida-normal.

       R-START-POR-IGUAL-PK-EXIT.
           move BENCHM-RECORD to BENCHM-RECORD-SAVED.
           move  1       to    start-pk.
           move  1       to    open-pk.
           move  rowid   to    rowid-start-pk.
           move  f-fun       to  lastopera.
           move  "sigpk "    to  lastcursor.
           go to  salida-normal.
      *------------------------------------- SIG AK1
       R-START-POR-IGUAL-AK1.
***********display "fbenchm- sig ak1".
           move  benchm-altky1  to  key1.
           if  f-size not = zeros
               compute desde = f-size + 1
               compute hasta = lngth-ak1 -  f-size
               move  low-values  to  BENCHM-altky1(desde:hasta).
           if  BENCHM-altky1  =  spaces
               move  2   to   f-flag
               move  f-fun       to  lastopera
               move  "sigak1"    to  lastcursor
               move  low-values  to  rowid-start-ak1
               move  zeros       to  start-ak1
               move  zeros       to  open-ak1
               go to  salida-normal.
***********display "fbenchm- sig open/fetch ak1".
           exec sql  begin work end-exec.
           exec sql  close cur_smi_ak1 end-exec.
           exec sql  open cur_smi_ak1 end-exec.
           exec sql  fetch cur_smi_ak1
                   into
                               :BENCHM-KEY1,:BENCHM-KEY2,
                               :BENCHM-DATOS1,
                               :BENCHM-ALTKY11,
                               :BENCHM-ALTKY12,
                               :BENCHM-ALTKY13,
                               :BENCHM-DATOS2, :BENCHM-DATOS3,
                               :BENCHM-ALTKY21,
                               :BENCHM-ALTKY22,
                               :BENCHM-ALTKY23,
                               :BENCHM-DATOS4, :rowid
           end-exec.
***********display sqlcode
           if  sqlcode not = zeros
               if  sqlcode  =  100
                   move  2  to  f-flag
                   move  f-fun       to  lastopera
                   move  "sigak1"    to  lastcursor
                   move  low-values  to  rowid-start-ak1
                   move  zeros       to  start-ak1
                   move  zeros       to  open-ak1
                   go to  salida-normal
               else
                   go to  muestro-error.
           if  f-size  =  zeros
               if  benchm-altky1  not =    key1
                   move  2  to  f-flag
                   move  f-fun       to  lastopera
                   move  "sigak1"    to  lastcursor
                   move  low-values  to  rowid-start-ak1
                   move  zeros       to  start-ak1
                   move  zeros       to  open-ak1
                   go to  salida-normal
               else
                   next sentence
               end-if
           else
               if  benchm-altky1(1:f-size)  not =   key1(1:f-size)
                   move  2  to  f-flag
                   move  f-fun       to  lastopera
                   move  "sigak1"    to  lastcursor
                   move  low-values  to  rowid-start-ak1
                   move  zeros       to  start-ak1
                   move  zeros       to  open-ak1
                   go to  salida-normal.
       R-START-POR-IGUAL-AK1-EXIT.
           move  1       to    start-ak1.
           move BENCHM-RECORD to BENCHM-RECORD-SAVED.
           move  1       to    open-ak1.
           move  rowid   to    rowid-start-ak1.
           move  f-fun       to  lastopera.
           move  "sigak1"    to  lastcursor.
           go to  salida-normal.


      **************************************************************
      ************************   WRI   *****************************
       R-WRITE.
***********display "fbenchm- insert  ".
           MOVE F-RECORD TO BENCHM-record.
           exec sql insert into benchm values
               ( :BENCHM-KEY1, :BENCHM-KEY2, :BENCHM-DATOS1,
                 :BENCHM-ALTKY11,
                 :BENCHM-ALTKY12,
                 :BENCHM-ALTKY13,
                 :BENCHM-DATOS2, :BENCHM-DATOS3,
                 :BENCHM-ALTKY21,
                 :BENCHM-ALTKY22,
                 :BENCHM-ALTKY23,
                 :BENCHM-DATOS4 )
           end-exec.
           exec sql commit work  end-exec.
           move  f-fun       to  lastopera.
           go to  salida-normal.


      **************************************************************
      ************************   REW   *****************************
       R-REWRITE.
***********display "fbenchm- update  ".
           if  not (lastopera = 2  or  6  or  10)
               move  2  to  f-flag
               move  f-fun  to  lastopera
               go to  salida-normal.
           MOVE  F-RECORD  TO  BENCHM-record.
               exec sql     update  benchm     set
                    bdatos1 = :BENCHM-DATOS1,
                    baltky11 = :BENCHM-ALTKY11,
                    baltky12 = :BENCHM-ALTKY12,
                    baltky13 = :BENCHM-ALTKY13,
                    bdatos2 = :BENCHM-DATOS2,
                    bdatos3 = :BENCHM-DATOS3,
                    baltky21 = :BENCHM-ALTKY21,
                    baltky22 = :BENCHM-ALTKY22,
                    baltky23 = :BENCHM-ALTKY23,
                    bdatos4 = :BENCHM-DATOS4
                        where rowid = :rowid
               end-exec.
           exec sql commit work  end-exec.
           move  f-fun       to  lastopera.
           go to  salida-normal.


      **************************************************************
      ************************   DEL   *****************************
       R-DELETE.
***********display "fbenchm- delete ".
           if  not (lastopera = 2  or  6  or  10)
               move  2  to  f-flag
               move  f-fun  to  lastopera
               go to  salida-normal.
           MOVE F-RECORD TO BENCHM-record.
           exec sql     delete  from benchm
                            where rowid = :rowid
           end-exec.
           exec sql commit work  end-exec.
           move  f-fun       to  lastopera.
           go to  salida-normal.


      **************************************************************
      ************************   CLO   *****************************
      ***********display "fbenchm- Cerrando cursores".
       R-CLOSE.
               exec sql  close cur_smi_pk   end-exec.
               exec sql  close cur_sma_pk   end-exec.
               exec sql  close cur_smi_ak1  end-exec.
               exec sql  close cur_sma_ak1  end-exec.
               exec sql  close cur_smi_ak2  end-exec.
               exec sql  close cur_sma_ak2  end-exec.
               go to  salida-normal.


      **************************************************************
      ************************   CRE   *****************************
       R-CREATE.
            call  "SYSTEM"   using
                 "sqlplus -s david/alcodag1 @create_benchm" X"00".
              go to  salida-normal.


      **************************************************************
      ************************   SCR   *****************************
       R-SCRATCH.
            call  "SYSTEM"   using
                 "sqlplus -s david/alcodag1 @drop_benchm" X"00".
              go to  salida-normal.


      *============================================================
      *============================================================
      *============================================================
       R-READ-PREVIO.
       R-READ-PREVIO-HOLD.
       R-START-POR-MENOR.
       R-START-POR-MENOR-IGUAL.
      ***********display "fbenchm- Funcion no Soportada Aun".
                 go to  muestro-error.


      ***************  Whenever not found / at end
       NORECFOUND.
***********display "fbenchm- NoRecFound "
                 move  2 to  f-flag.
                 go to  salida-normal.


      ***************  Rutina de tratamiento de errores
       MUESTRO-ERROR.
***********display "fbenchm- Error".
      *---- Agregar llamadas a OVERROR y devolver filstat1 y 2.
                 perform  displsqlca.
                 move  2 to  f-flag.
                 stop run.


       DISPLSQLCA.
***********display "SQLCA "
****                  " sqlcode  " sqlcode  "***".


      ***************  Computo de tiempos
031300 TIEMPOS.
031400      ACCEPT  TT   FROM TIME.
031500      COMPUTE TTW = (HH * 360000) + (MM * 6000) + (SS * 100) + CC.

